VB.net进行CAD二次开发(二)与cad交互

开发过程遇到了一个问题:自制窗口与控件与CAD的交互。

启动类,调用非模式窗口

Imports Autodesk.AutoCAD.Runtime

Public Class Class1

    '//CAD启动界面
    <CommandMethod("US")>
    Public Sub UiStart()

        Dim myfrom As Form1 = New Form1()
        'Autodesk.AutoCAD.ApplicationServices.Application.ShowModalDialog(myfrom); //  模态显示
        '; //  非模态显示
        Autodesk.AutoCAD.ApplicationServices.Application.ShowModelessDialog(myfrom)

    End Sub
End Class

非模式窗体

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms


Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.EditorInput
Imports System.Runtime.InteropServices
Imports Application = Autodesk.AutoCAD.ApplicationServices.Application
Public Class Form1

    Dim db As Database = HostApplicationServices.WorkingDatabase
    Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
    Dim doc As Document = Application.DocumentManager.MdiActiveDocument

    Public Property MyDoc() As Document
        Get
            Return doc
        End Get
        Set(ByVal value As Document)
            doc = value
        End Set
    End Property

'调用windows all的命令,两种方法都可以
    ' <DllImport("user32.DLL")> _
    '  Public Shared Function SetFocus(ByVal hWnd As IntPtr) As Integer

    'End Function

    Public Declare Function SetFocus Lib "USER32.DLL" (ByVal hWnd As Integer) As Integer

    Public Sub New()
        InitializeComponent()
        SetFocus(doc.Window.Handle)
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        ed.WriteMessage("欢迎使用批量统计线段长度小工具,请框选线段!\n")

        '在界面开发中,操作图元时,首先进行文档锁定 ,利用using 语句变量作用范围,结束时自动解锁文档
        Using docLock As DocumentLock = doc.LockDocument()
            '过滤删选条件设置 过滤器
            Dim typedValues(0) As TypedValue
            typedValues.SetValue(New TypedValue(0, "*LINE"), 0)

            Dim sSet As SelectionSet = SelectSsGet("GetSelection", Nothing, typedValues)
            Dim sumLen As Double = 0
            ' 判断是否选取了对象
            If sSet IsNot Nothing Then
                '遍历选择集
                For Each sSObj As SelectedObject In sSet
                    ' 确认返回的是合法的SelectedObject对象  
                    If sSObj IsNot Nothing Then

                        '开启事务处理
                        Using trans As Transaction = db.TransactionManager.StartTransaction()
                            Dim curEnt As Curve = trans.GetObject(sSObj.ObjectId, OpenMode.ForRead)
                            ' 调整文字位置点和对齐点
                            Dim endPoint As Point3d = curEnt.EndPoint
                            'GetDisAtPoint 用于返回起点到终点的长度 传入终点坐标
                            Dim lineLength As Double = curEnt.GetDistAtPoint(endPoint)
                            ed.WriteMessage("\n" + lineLength.ToString())
                            sumLen = sumLen + lineLength
                            trans.Commit()
                        End Using
                    End If
                Next
            End If         'using 语句 结束,括号内所有对象自动销毁,不需要手动dispose()去销毁
            ed.WriteMessage("\n 线段总长为: " & (sumLen.ToString()))
        End Using
    End Sub

    Public Function SelectSsGet(ByVal selectStr As String, ByVal point3dCollection As Point3dCollection, ByVal typedValue() As TypedValue) As SelectionSet

        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
        '将过滤条件赋值给SelectionFilter对象
        Dim selfilter As SelectionFilter = Nothing
        If typedValue IsNot Nothing Then
            selfilter = New SelectionFilter(typedValue)
        End If
        ' 请求在图形区域选择对象

        Dim psr As PromptSelectionResult
        If selectStr = "GetSelection" Then  '提示用户从图形文件中选取对象

            psr = ed.GetSelection(selfilter)

        ElseIf (selectStr = "SelectAll") Then '选择当前空间内所有未锁定及未冻结的对象

            psr = ed.SelectAll(selfilter)

        ElseIf selectStr = "SelectCrossingPolygon" Then '选择由给定点定义的多边形内的所有对象以及与多边形相交的对象。多边形可以是任意形状,但不能与自己交叉或接触。

            psr = ed.SelectCrossingPolygon(point3dCollection, selfilter)

            '选择与选择围栏相交的所有对象。围栏选择与多边形选择类似,所不同的是围栏不是封闭的, 围栏同样不能与自己相交
        ElseIf selectStr = "SelectFence" Then

            psr = ed.SelectFence(point3dCollection, selfilter)

            '选择完全框入由点定义的多边形内的对象。多边形可以是任意形状,但不能与自己交叉或接触
        ElseIf selectStr = "SelectWindowPolygon" Then

            psr = ed.SelectWindowPolygon(point3dCollection, selfilter)

        ElseIf selectStr = "SelectCrossingWindow" Then  '选择由两个点定义的窗口内的对象以及与窗口相交的对象

            Dim point1 As Point3d = point3dCollection(0)
            Dim point2 As Point3d = point3dCollection(1)
            psr = ed.SelectCrossingWindow(point1, point2, selfilter)

        ElseIf selectStr = "SelectWindow" Then '选择完全框入由两个点定义的矩形内的所有对象。

            Dim point1 As Point3d = point3dCollection(0)
            Dim point2 As Point3d = point3dCollection(1)
            psr = ed.SelectCrossingWindow(point1, point2, selfilter)
        Else
            Return Nothing
        End If

        '// 如果提示状态OK,表示对象已选
        If psr.Status = PromptStatus.OK Then
            Dim sSet As SelectionSet = psr.Value
            ed.WriteMessage("Number of objects selected: " + sSet.Count.ToString() + "\n") '打印选择对象数量
            Return sSet
        Else
            ' 打印选择对象数量
            ed.WriteMessage("Number of objects selected 0 \n")
            Return Nothing
        End If


    End Function


End Class

参考文献

https://zhuanlan.zhihu.com/p/138579148

VB.NET自动操作其他程序(2)--声明DLL相关函数 - zs李四 - 博客园

本文来自互联网用户投稿,该文观点仅代表作者本人,不代表本站立场。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如若转载,请注明出处:http://www.mzph.cn/pingmian/63485.shtml

如若内容造成侵权/违法违规/事实不符,请联系多彩编程网进行投诉反馈email:809451989@qq.com,一经查实,立即删除!

相关文章

linux ls -l 输出 drwxr-xr-x 2 root root 4096 Dec 5 21:48 rootTest 是什么意思

在Linux系统中&#xff0c;ls -l命令用于以长格式列出目录内容的详细信息。输出的一行通常包含以下部分&#xff1a; drwxr-xr-x 2 root root 4096 Dec 5 21:48 rootTest这一行的各个部分意义如下&#xff1a; drwxr-xr-x&#xff1a;这是文件类型和权限的标识。 第一个字符d…

python学opencv|读取图像(五)读取灰度图像像素

【1】引言 前序学习了图像的基本读取&#xff0c;掌握了imread()、imshow()和imwrite()函数的基本功能和使用技巧&#xff0c;参考文章链接为&#xff1a; python学opencv|读取图像-CSDN博客 然后陆续掌握了彩色图像保存、图像放大和缩小以及对imshow()函数的大胆尝试技巧&a…

基于yolov8的SAR影像目标检测系统,支持图像、视频和摄像实时检测【pytorch框架、python源码】

更多目标检测、图像分类识别、目标追踪等项目可看我主页其他文章 功能演示&#xff1a; 基于yolov8的SAR影像目标检测系统&#xff0c;支持图像、视频和摄像实时检测【pytorch框架、python源码】_哔哩哔哩_bilibili &#xff08;一&#xff09;简介 基于yolov8的SAR影像目标…

2.Flink的项目初始化和Hello-world

目录 1.Flink项目初始化 2.Hello-world 1.Flink项目初始化 新建maven项目或者gradle项目&#xff0c;这里使用maven项目为例。 在项目的pom.xml文件中添加Flink依赖&#xff0c;如下所示&#xff0c;为Hello-World例子的最小依赖&#xff1a; <properties><maven.c…

ESP32开发 云调试

https://blog.csdn.net/weixin_43794311/article/details/128722001 VScode支持的仿真平台 https://docs.wokwi.com/zh-CN/vscode/getting-started 编译&#xff1a;Ctrl Alt B上传并重启模拟器&#xff1a;CtrlShifB Wokwi:Start Simulator调试&#xff1a;CtrlShifB Wokwi…

如何写出一篇好的论文?

写出一篇好的论文需要综合多方面的要素&#xff0c;从选题到最终成文&#xff0c;每一步都至关重要。首先&#xff0c;明确研究主题和目标&#xff0c;确保选题具有创新性、可行性和实际意义。接着&#xff0c;进行深入的文献检索和综述&#xff0c;了解当前领域的研究现状和前…

模版方法模式的理解和实践

在软件开发中&#xff0c;设计模式为我们提供了一套经过验证的解决方案&#xff0c;用于解决常见的设计问题。其中&#xff0c;模版方法模式&#xff08;Template Method Pattern&#xff09;是一种行为设计模式&#xff0c;它定义了一个算法的框架&#xff0c;并允许子类在不改…

洛谷【排序】算法的题单 - 笔记

2024-12-09 - 第 37 篇 洛谷【排序】题单 - 笔记 作者(Author): 郑龙浩 / 仟濹(CSND账号名) 洛谷【排序】题单合集 一、排序算法都有… 1. 简单排序算法 这些算法通常是基础的排序方法&#xff0c;容易理解和实现&#xff0c;但效率较低&#xff0c;适用于数据量较小的情况…

MySQL--》如何在SQL中巧妙运用函数与约束,优化数据处理与验证?

目录 函数使用 字符串函数 数值函数 日期函数 流程函数 约束 函数使用 函数是指一段可以直接被另一段程序调用的程序或代码&#xff0c;在mysql当中有许多常见的内置函数&#xff0c;接下来开始对这些内置函数及其作用进行简单的讲解和使用&#xff1a; 字符串函数 my…

归有光,情感与真实的独行者

归有光&#xff0c;字熙甫&#xff0c;号震川&#xff0c;生于明孝宗弘治十年&#xff08;公元1507年&#xff09;&#xff0c;卒于明穆宗隆庆五年&#xff08;公元1571年&#xff09;&#xff0c;享年64岁。他是中国明代著名的散文家、文学家和史学家&#xff0c;其散文风格清…

Python + OpenCV 系列:图像阈值处理

文章目录 引言 1. 阈值处理的基本概念2. OpenCV 中的阈值处理3. 常见的阈值类型3.1 二值化阈值3.2 反向二值化阈值3.3 截断阈值3.4 平滑阈值 4. 自适应阈值5. Otsu’s 阈值法6. 阈值处理的应用场景7. 总结 引言 图像阈值处理是计算机视觉和图像处理中一种非常基础而重要的技术…

计算机网络-Wireshark探索ARP

使用工具 Wiresharkarp: To inspect and clear the cache used by the ARP protocol on your computer.curl(MacOS)ifconfig(MacOS or Linux): to inspect the state of your computer’s network interface.route/netstat: To inspect the routes used by your computer.Brows…

Vue3小兔鲜电商项目

创建项目 npm install 装包

【NLP 12、深度学习15条调参经验】

反正是绚烂&#xff0c;反正是到来 反正是背负慢慢凋残的孤独 耀眼的孤独&#xff0c;义无反顾的孤独 —— 24.12.9 深度学习15条调参经验 1.调参 调参是锦上添花的事&#xff0c;而底线取决于模型的选择和数据的清洗 2.关于model ① 尽量不要自己手写模型&#xff0c;找一…

美畅物联丨视频接入网关如何配置 HTTPS 证书

在安防领域&#xff0c;视频接入网关&#xff08;Video Access Gateway&#xff0c;VAG&#xff09;是视频监控系统的重要组成部分&#xff0c;其职责是把视频数据从前端设备传输至后端服务器。配置HTTPS证书后&#xff0c;可对视频流进行加密传输&#xff0c;避免数据在网络传…

fastcam编程套料软件

Fastcam是一款功能强大的专业软件&#xff0c;以下是对它的具体介绍&#xff1a; 基本信息 • Fastcam自1982年推出首个交互式CNC编程和套料系统后&#xff0c;一直不断更新发展. • 它是为数控火焰、等离子、激光和水射流切割机等数控切割机开发的编程套料软件. 主要功能模…

【大语言模型】LangChain ModelsIO与Models I/O Promopts详解

【大语言模型】LangChain ModelsIO与Prompts详解 一、LangChain ModelsIO1、简介2、Models I/O 的应用场景3、Models I/O 主要模块3.1、Prompts3.2、Modelsa、MESSAGES 类型 3.3、Output Parsers 二、LangChain ModelsIO Prompts1、简介2、Prompts 的优点3、实战示例3.1、Promp…

MicroBlaze软核开发(三):DDR + FLASH

实现功能&#xff1a;使用 MicroBlaze软核&#xff0c;配置 DDR、Flash 接口&#xff0c;并将程序烧写固化到Flash&#xff0c;每次启动 FPGA 时自动运行 Flash 中的程序 。 Vivado版本&#xff1a;2018.3 FPGA&#xff1a;Xilinx Artix-7 系 目录 引言 Vivado部分&#xff1…

Springboot(五十三)SpringBoot3整合redisson

前边我们有记录Springboot2/3整合redis的方式。是基于Springboot默认集成的Lettuce客户端实现的。 今天我们在项目中集成的redission是在Lettuce之上构建的redis客户端。 Redisson:一个在Jedis和Lettuce之上构建的Redis客户端。提供了一系列分布式Java对象和服务,比如:分布式…

渗透测试基础

渗透测试基础是指对计算机系统、网络或应用程序进行模拟攻击&#xff0c;以发现其安全漏洞和潜在威胁的一种安全评估技术。通过模拟真实的攻击场景&#xff0c;渗透测试帮助组织了解其系统的安全弱点、验证防护措施的有效性&#xff0c;并提供改进建议。 渗透测试的核心概念 1…